package com.flutter_dhl_amap.Search;

import android.content.Context;

import com.amap.api.services.core.LatLonPoint;
import com.amap.api.services.route.DistanceItem;
import com.amap.api.services.route.DistanceResult;
import com.amap.api.services.route.DistanceSearch;
import com.flutter_dhl_amap.Class.ConstraintsArray;
import com.flutter_dhl_amap.Class.ConstraintsMap;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import io.flutter.plugin.common.EventChannel;

public class DHL_DistanceSearch implements DistanceSearch.OnDistanceSearchListener {
    private EventChannel.EventSink eventSink;
    private Context context;
    private DistanceSearch distanceSearch;
    public DHL_DistanceSearch(Context context,   EventChannel.EventSink eventSink){
        this.eventSink = eventSink;
        this.context = context;
        distanceSearch = new DistanceSearch(this.context );
        distanceSearch.setDistanceSearchListener(this);


    }
    public void jisuan(ConstraintsMap map){

        int type= map.getInt("type");
        Double slatitude= map.getDouble("slatitude");
        Double slongitude= map.getDouble("slongitude");
        Double elatitude= map.getDouble("elatitude");
        Double elongitude= map.getDouble("elongitude");
        if(slatitude != 0 && slongitude!=0&&elatitude!=0&&elongitude!=0){

            DistanceSearch.DistanceQuery distanceQuery =  new DistanceSearch.DistanceQuery();
            LatLonPoint start = new LatLonPoint(slatitude, slongitude);
            LatLonPoint start1 = new LatLonPoint(elatitude, elongitude);
            List<LatLonPoint> latLonPoints = new ArrayList<LatLonPoint>();
            latLonPoints.add(start);

            distanceQuery.setOrigins(latLonPoints);
            distanceQuery.setDestination(start1);
            distanceQuery.setType(DistanceSearch.TYPE_DRIVING_DISTANCE);
            distanceSearch.calculateRouteDistanceAsyn(distanceQuery);

        }


    }

    @Override
    public void onDistanceSearched(DistanceResult distanceResult, int i) {
        if(i==1000){
            List<DistanceItem> distanceResults = distanceResult.getDistanceResults();
            ConstraintsArray array = new ConstraintsArray();
            DistanceItem distanceItem;
            for (int j = 0; j <distanceResults.size() ; j++) {
                distanceItem = distanceResults.get(j);
                ConstraintsMap map = new ConstraintsMap();
                map.putInt("originID",distanceItem.getOriginId());
                map.putInt("destID",distanceItem.getDestId());
                map.putDouble("distance",distanceItem.getDistance());
                map.putInt("duration",distanceItem.getOriginId());
                map.putInt("code",distanceItem.getErrorCode());
                map.putString("info",distanceItem.getErrorInfo());
                array.pushMap(map);
            }
            eventSink.success(array.toArrayList());
        }

    }
}
