#import "FlutterDhlAmapPlugin.h"
#import "FlutterDhlAmapEvent.h"
#import <AMapFoundationKit/AMapFoundationKit.h>
#import "location_class/DHL_LocationModel.h"
#import <AMapLocationKit/AMapLocationKit.h>

#import <AMapSearchKit/AMapSearchKit.h>

#import "MyViewFlutterPlugin.h"
@implementation FlutterDhlAmapPlugin
    DHL_LocationModel *locationModel ;
//事件处理
FlutterDhlAmapEvent *flutterDhlAmapEvent;

FlutterDhlAmapEvent *flutterDhlAmapSearchEvent;

    
    AMapLocationManager *locationManager; //监控定位
AMapDistanceSearchRequest *SearchRequest;//两个点之间到距离

AMapSearchAPI *search;//搜索对象

+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"flutter_dhl_amap"
            binaryMessenger:[registrar messenger]];
  FlutterDhlAmapPlugin* instance = [[FlutterDhlAmapPlugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];
    
    [MyViewFlutterPlugin registerWithRegistrar:registrar];//高德地图view
    
    
    //事件处理
    flutterDhlAmapEvent = [[FlutterDhlAmapEvent alloc] init];
    flutterDhlAmapEvent.eventChannel = [FlutterEventChannel
                                eventChannelWithName:@"flutter_dhl_amap_location"
                                binaryMessenger:[registrar messenger]];
    [flutterDhlAmapEvent.eventChannel setStreamHandler:flutterDhlAmapEvent];
    
    
    //s计算监听
    flutterDhlAmapSearchEvent = [[FlutterDhlAmapEvent alloc] init];
    flutterDhlAmapSearchEvent.eventChannel = [FlutterEventChannel
                                        eventChannelWithName:@"flutter_dhl_amap_Search"
                                        binaryMessenger:[registrar messenger]];
    [flutterDhlAmapSearchEvent.eventChannel setStreamHandler:flutterDhlAmapSearchEvent];
    
    

   
    
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
  if ([@"getPlatformVersion" isEqualToString:call.method]) {
    result([@"iOS " stringByAppendingString:[[UIDevice currentDevice] systemVersion]]);
      
  }else if([@"init" isEqualToString:call.method]){
      NSString *key = call.arguments;
      [AMapServices sharedServices].apiKey = key;
      [AMapServices sharedServices].enableHTTPS = YES;
      
      SearchRequest = [[AMapDistanceSearchRequest alloc] init];
      
      search =[[AMapSearchAPI alloc] init];
      search.delegate=self;//监听搜索
      
  }else if([@"start_location" isEqualToString:call.method]){//开始定位
      NSDictionary *data2 = call.arguments;
      locationModel = [[DHL_LocationModel alloc] initWithLocationModel:data2  flutterDhlAmapEvent:flutterDhlAmapEvent ]; 
  }else if([@"stop_location" isEqualToString:call.method]){//停止定位
     
      [locationModel stopLocatiom];
  } else if([@"zhuan_location" isEqualToString:call.method]){//a转化坐标 type : gaode  baidu
    NSDictionary *data2 = call.arguments;
      
      CLLocationDegrees latitude = [data2[@"latitude"] floatValue];//floatValue
      CLLocationDegrees longitude = [data2[@"longitude"] floatValue];//floatValue
      if(latitude != 0 && longitude!= 0){
          int de = 0 ;
          NSString *tyoe = data2[@"type"];
          if(![tyoe  isEqual: @"gaode"]){
              de = -1;
          }
          CLLocationCoordinate2D amapcoord = AMapCoordinateConvert(CLLocationCoordinate2DMake(latitude,longitude), de);

          result(@{
                   @"latitude" :@( amapcoord.latitude),
                   @"longitude" : @(amapcoord.longitude),
                   });
      }
      
      result(@{
          @"latitude" :@( 0.00),
          @"longitude" : @(0.00),
      });
      
      

  }else if([@"jisuan_location" isEqualToString:call.method]){
      NSDictionary *data2 = call.arguments;

      CLLocationDegrees slatitude = [data2[@"slatitude"] floatValue];//floatValue
      CLLocationDegrees slongitude = [data2[@"slongitude"] floatValue];//floatValue..
      
      CLLocationDegrees elatitude = [data2[@"elatitude"] floatValue];//floatValue
      CLLocationDegrees elongitude = [data2[@"elongitude"] floatValue];//floatValue..
      if(slatitude!=0 && slongitude!=0 && elatitude!=0 && elongitude!=0 ){
          SearchRequest = [[AMapDistanceSearchRequest alloc] init];
          SearchRequest.origins = @[
                                    [AMapGeoPoint locationWithLatitude:slatitude longitude:slongitude]];
          SearchRequest.destination = [AMapGeoPoint locationWithLatitude:elatitude longitude:elongitude];
          ///路径计算的方式和方法.0：直线距离; 1：驾车导航距离（仅支持国内坐标）此时会考虑路况，故在不同时间请求返回结果可能不同，此策略和driving接口的 strategy=4策略一致; 默认为1
          int type = [data2[@"type"] intValue];
          SearchRequest.type = type;
          
          [search AMapDistanceSearch:SearchRequest];
      }
      
  }else {
    result(FlutterMethodNotImplemented);
  }
}
//监听计算
- (void)onDistanceSearchDone:(AMapDistanceSearchRequest *)request response:(AMapDistanceSearchResponse *)response//计算距离的回调
{
    
    NSArray<AMapDistanceResult *> *results = response.results;
    NSInteger count = results.count;
     NSArray * arr = [[ NSArray alloc]init];
    for (NSInteger i=0; i<count; i++) {
        AMapDistanceResult *res =  results[i];
        id  originID = [res valueForKey:@"originID"];
        id  destID = [res valueForKey:@"destID"];
        id  distance = [res valueForKey:@"distance"];
        id  duration = [res valueForKey:@"duration"];
        id  code = [res valueForKey:@"code"];
        NSString  *info =[res valueForKey:@"info"];
      
        arr = [arr arrayByAddingObject:@{
                                         @"originID":@([originID intValue]),
                                         @"destID": @([destID intValue]),
                                         @"distance":  @([distance intValue]),
                                         @"duration":  @([duration intValue]),
                                         @"code": @([code intValue]),
                                         @"info": info == NULL ?@"":info,
                                         }];
    }
    NSDictionary   *arr2 = arr;
   
    
    FlutterEventSink eventSink =  flutterDhlAmapSearchEvent .eventSink;
    if(eventSink){
        eventSink(arr2);
    }
    //duration
}
- (void)AMapSearchRequest:(id)request didFailWithError:(NSError *)error{
    NSLog(@"%@", error);
    
}

@end
