import 'dart:io';
import 'package:flutter/foundation.dart';
import 'package:flutter/gestures.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'DHL_aMapView_Model.dart';

class DHL_aMapView extends StatelessWidget {
  final DHL_aMapView_Model dhlAMapViewModel;
  const DHL_aMapView( {
    Key key,
    this.dhlAMapViewModel =  const DHL_aMapView_Model()

  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    Map<String, Object> ddd = dhlAMapViewModel.toJson();
    if(Platform.isIOS){
      return UiKitView(
        viewType: 'Dhl_MyAmap_View',
        creationParams: ddd,
        creationParamsCodec: const StandardMessageCodec(),
        onPlatformViewCreated: onMyViewCreated,
      );
    }else if(Platform.isAndroid){


      return AndroidView(
        viewType: 'Dhl_MyAmap_View',
        creationParams: ddd,
        creationParamsCodec: const StandardMessageCodec(),
        onPlatformViewCreated: onMyViewCreated,
      );
    }

  }

  static MethodChannel _channel;


  void onMyViewCreated(int id) {
    _channel = new MethodChannel('Dhl_MyAmap_View_$id');
    setMyViewText("");
  }

  //设置我的坐标点 的标题和内容  空的话就保持不修改
  Future<void> SetMymarkerContent(String title , String snippet) async {
    if(_channel == null)return "";
    return _channel.invokeMethod('SetMymarkerContent', {"title":title,"snippet":snippet});
  }
  //设置定位
  Future<void> SetCoordinate(double latitude , double longitude) async {
    if(_channel == null)return "";

    return _channel.invokeMethod('SetCoordinate', {"latitude":latitude,"longitude":longitude});
  }

  Future<void> setMyViewText(String text) async {
    assert(text != null);
   // return _channel.invokeMethod('setText', text);
  }

  //添加Marker  is_show 是否展示 信息框
  Future<void> AddMarker(double latitude , double longitude,String title , String snippet,String key , bool is_show) async {
    if(_channel == null)return "";
    if(key == null || key == "")return "";//key不能为空
    return _channel.invokeMethod('AddMarker', {"latitude":latitude,"longitude":longitude,"title":title,"snippet":snippet,"key":key,"is_show":is_show});
  }

  //更新Marker
  Future<void> UpdateMarker(double latitude , double longitude,String title , String snippet,String key ) async {
    if(_channel == null)return "";
    if(key == null || key == "")return "";//key不能为空
    return _channel.invokeMethod('UpdateMarker', {"latitude":latitude,"longitude":longitude,"title":title,"snippet":snippet,"key":key});
  }
  //更改Marker的信息框是否显示
  Future<void> UpdateMarkerShow(String key , bool is_show) async {
    if(_channel == null)return "";
    if(key == null || key == "")return "";//key不能为空
    return _channel.invokeMethod('UpdateMarkerShow', { "key":key,"is_show":is_show});
  }

  //删除Marker的信息框是否显示
  Future<void> DelMarkerShow(String key  ) async {
    if(_channel == null)return "";
    if(key == null || key == "")return "";//key不能为空
    return _channel.invokeMethod('DelMarkerShow', { "key":key });
  }

  //删除全部Marker的信息框是否显示
//  Future<void> DelAllMarkerShow(   ) async {
//    if(_channel == null)return "";
//
//    return _channel.invokeMethod('DelAllMarkerShow', );
//  }

}


