import 'dart:io';


class DHL_aMapView_Model{
  //是否开启一个跟我定位一样的标记点  会在使用 SetCoordinate 的时候更改定位 默认开启
  final bool IsMyMarker;
  //缩放按钮 默认关闭
  final bool setZoomControlsEnabled;

  //指南针 默认关闭
  final bool setCompassEnabled;

  //定位按钮 默认关闭
  final bool setMyLocationButtonEnabled;

  //比例尺控件 默认关闭
  final bool setScaleControlsEnabled;

  //缩放手势 默认关闭
  final bool setZoomGesturesEnabled;

  //滑动手势 默认开启
  final bool setScrollGesturesEnabled;

  //旋转手势 默认开启
  final bool setRotateGesturesEnabled;

  //倾斜手势 默认开启
  final bool setTiltGesturesEnabled;

  //指定屏幕中心点的手势操作 默认开启
  final bool setGestureScaleByMapCenter;



  //最大缩放 17
  final int setMaxZoomLevel;

  //最小缩放 10
  final int setMinZoomLevel;



  //设置连续定位模式下的定位间隔，只在连续定位模式下生效，单次定位模式下不会生效。单位为毫秒。 2000
  final int interval;

  //设置是否显示定位小蓝点 默认开启
  final bool showMyLocation;

  //设置为true表示启动显示定位蓝点
  final bool setMyLocationEnabled;

  const DHL_aMapView_Model({
    this.IsMyMarker = true,
    this.setZoomControlsEnabled = false,
    this.setCompassEnabled = false,
    this.setMyLocationButtonEnabled = false,
    this.setScaleControlsEnabled = false,
    this.setZoomGesturesEnabled = false,
    this.setScrollGesturesEnabled = true,
    this.setRotateGesturesEnabled = true,
    this.setTiltGesturesEnabled = true,
    this.setGestureScaleByMapCenter = true,
    this.setMaxZoomLevel = 17,
    this.setMinZoomLevel = 10,
    this.interval = 2000,
    this.showMyLocation = true,
    this.setMyLocationEnabled = true
  });


  DHL_aMapView_Model fromMap(dynamic map){
    return new DHL_aMapView_Model(
      IsMyMarker :map["IsMyMarker"],
      setZoomControlsEnabled :map["setZoomControlsEnabled"],
      setCompassEnabled :map["setCompassEnabled"],
      setMyLocationButtonEnabled :map["setMyLocationButtonEnabled"],
      setScaleControlsEnabled :map["setScaleControlsEnabled"],
      setZoomGesturesEnabled :map["setZoomGesturesEnabled"],
      setScrollGesturesEnabled :map["setScrollGesturesEnabled"],
      setRotateGesturesEnabled :map["setRotateGesturesEnabled"],
      setTiltGesturesEnabled :map["setTiltGesturesEnabled"],
      setGestureScaleByMapCenter :map["setGestureScaleByMapCenter"],
      setMaxZoomLevel :map["setMaxZoomLevel"],
      setMinZoomLevel :map["setMinZoomLevel"],
      interval :map["interval"],
      showMyLocation :map["showMyLocation"],
      setMyLocationEnabled :map["setMyLocationEnabled"],
    );

  }

  Map<String, Object> toJson() {
    return {
      'IsMyMarker': IsMyMarker,
      'setZoomControlsEnabled': setZoomControlsEnabled,
      'setCompassEnabled': setCompassEnabled,
      'setMyLocationButtonEnabled': setMyLocationButtonEnabled,
      'setScaleControlsEnabled': setScaleControlsEnabled,
      'setZoomGesturesEnabled': setZoomGesturesEnabled,
      'setScrollGesturesEnabled': setScrollGesturesEnabled,
      'setRotateGesturesEnabled': setRotateGesturesEnabled,
      'setTiltGesturesEnabled': setTiltGesturesEnabled,
      'setGestureScaleByMapCenter': setGestureScaleByMapCenter,
      'setMaxZoomLevel': setMaxZoomLevel,
      'setMinZoomLevel': setMinZoomLevel,
      'interval': interval,
      'showMyLocation': showMyLocation,
      'setMyLocationEnabled': setMyLocationEnabled,
    };
  }



}